ECHO OFF
bat CLS BEGTYPE
 \0EPRTDIR  print status of specified disk(ette) drive\07
       02/25/86  DPbyDB  Huntington Woods, MI 48070

END
rem      11/14/85  dab
rem                Using NORTON UTILITIES v3.10
rem                Using EXTENDED BATCH LANGUAGE v2.04
rem      02/12/86  dab
rem                Substitute public domain SDIR24C for
rem                      DOS 'DIR' command
rem                If %2 = PRN  ask if TOF is desired
rem      02/25/86  dab
rem                Substitute public domain EFFIC for
rem                      NORTON DIRSORT command
rem                Sort directory by name via SDIR24C

bat * Check if PRN selected as output file on command line
bat *       if PRN NOT selected, use default log name
bat IF .%2 = . %2 = %0.LOG | SKIP 1
bat IF %2 <> PRN %2 = %0.LOG
bat * Check validity of disk parameter on command line
bat IF .%1 <> . %3 = %1 $ 1 1 | SKIP 4

bat -rd.1 INKEY     Which disk(ette)? (A-D or Q) %3
bat IF %3 > KEY BEEP TYPE | GOTO -rd.1
bat TYPE %3
bat CALL -chker | %1 = %3 | IF .%3 = . GOTO -rd.1
bat IF %1 = Q GOTO -exit

rem      NORTON tm.com   [elapsed time logger]
TM START /C1/L/LOG>%2
TM START /C2/L/LOG
bat TYPE
echo ** %1: Drive Directory Information **
bat BEGTYPE
 \82         Step 1 of 4\07
END

rem      DOS chkdsk.com  [standard disk(ette) I/O status]
CHKDSK %1:>>%2
bat *  re-display step again
bat BEGTYPE
 \00\48 ;
        Step 1 of 4\07 ... ;
END
TM STOP /C2/L/N
TM START /C2/L/LOG/N
bat BEGTYPE
 \82         Step 2 of 4\07
END

rem      NORTON dt.com   [enhanced disk(ette) I/O status]
DT %1:/D/LOG>>%2
bat *  re-display step again
bat BEGTYPE
 \00\48 ;
        Step 2 of 4\07 ... ;
END
TM STOP /C2/L/N
TM START /C2/L/LOG/N
bat BEGTYPE
 \82         Step 3 of 4\07 ;
END

rem      Public Domain   [EFFIC.PAS - disk efficiency ]
rem                      [-Q    - non contigous only  ]
rem                      [-S    - use designated drive]
EFFIC -Q -S %1:>>%2
bat *  re-display step again
bat BEGTYPE
 \00\48 ;
        Step 3 of 4\07 ... ;
END
TM STOP /C2/L/N
TM START /C2/L/LOG/N
bat BEGTYPE
 \82         Step 4 of 4\07
END

rem      Public Domain   [directory list] [/A - display Hidden files]
rem                                       [/E - no screen erase     ]
SDIR24C %1:/A/E>>%2
bat *  re-display step again
bat BEGTYPE
 \00\48 ;
        Step 4 of 4\07 ... ;
END
TM STOP /C2/L/N
bat IF %2 = %0.LOG SKIP 11

bat -rd.2 TYPE
bat INKEY Top-of-form desired? (Y/N) %A
bat TYPE %A
bat IF %A = Y SKIP 3
bat IF %A = N GOTO -exit
bat GOTO -rd.2

TOF
bat GOTO -exit

bat TYPE
echo %0 has completed successfully ... Results are in %2

bat -exit
bat *  display total elapsed time
bat BEGTYPE
 \00\48 ;
        All Steps  \07 ... ;
END
TM STOP /C1/L/N
bat EXIT

rem      subroutine which checks the drive spec for validity.
bat -chker
bat     IF %3 = Q SKIP 5
bat     IF %3 = A SKIP 4
bat     IF %3 = B SKIP 3
bat     IF %3 = C SKIP 2
bat     IF %3 = D SKIP 1
bat     BEEP %3 =
bat -chk.ok RETURN

